/*
 *	Novell VAP Server Definitions
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this program is strictly prohibited.
 *
 *      Copyright (c) 1987, 1988, 1989 FairCom Corporation
 *	(Subject to limited distribution and
 *	 restricted disclosure only.)
 *	*** ALL RIGHTS RESERVED ***
 *
 *	4006 West Broadway
 *	Columbia, MO 65203
 *
 *
 *	c-tree(R)	Version 4.3
 *			Release C
 *			February 7, 1989 17:30
 *
 */

/*
 * The following defines specifiy the default maximums. They may be over-
 * ridden on the server command line.  The server command line is
 * controlled in function getsenv() [found in CTSRVE.C].
 */

#define CTS_MAXSMSG	534	/* maximum server message size		*/
#define CTS_MAXUSR	16	/* maximum number of users		*/
#define CTS_MAXFIL	200	/* maximum number of files		*/
#define CTS_NODSEC	4 	/* number of node sectors		*/
#define CTS_BUFFER	32	/* number of index buffers		*/
#define CTS_MAXLOK	128	/* maximum number of record ct_locks	*/
#define CTS_DOWN	4	/* shut down tries + 1			*/
#define CTS_KEYOPS	(2 * MAX_DAT_KEY)
				/* maximum combined index operations	*/

#define NO_RQST		8	/* no request for server		*/

typedef struct message {/* message header structure			*/
	POINTER	mpntr;	/* file position (byte offset)			*/
	VRLEN	mvlen;	/* variable length count			*/
	COUNT	musrn,	/* user number					*/
		mfiln,	/* c-tree file number				*/
		mfunc,	/* function number				*/
		mdlen,	/* byte count for mdata buffer			*/
		merrn,	/* c-tree error code				*/
		mretc,	/* return code					*/
		mseqn;	/* sequence number and/or misc COUNT parm	*/
	} MESSAGE;

typedef struct fileparm {
	TEXT	fpnam[MAX_NAME];	/* file name			*/
	UCOUNT	fplen,			/* length			*/
		fpxtd;			/* extension chunk size		*/
	COUNT	fptyp,			/* key type			*/
		fpdup,			/* duplicate flag		*/
		fpmem,			/* index member			*/
		fpmod;			/* file mode			*/
	} FILEPARM;

typedef struct {
	COUNT	spns;
	COUNT	spbf;
	UCOUNT	spsz;
	COUNT	splk;
	COUNT	spky;
	} SRVPRM;

typedef struct {
	LONG	srqsts,
		susers,
		strans,
		scts_wl,
		scts_rl,
		scts_ul,
		sredo,
		ssets,
		swaks,
		suwaks,
		sretry,
		shtdwn;
} SSTATUS;

/* Function Numbers */

#define FN_ADDKEY	1
#define FN_DELCHK	2
#define FN_DELBLD	3
#define FN_CLSFIL	4
#define FN_INTREE	5
#define FN_CREMEM	6
#define FN_DELFIL	7

#define FN_FOPNCRE	10
#define FN_OPNFIL	11

#define FN_CREDAT	21
#define FN_CREIDX	22
#define FN_LOPNCRE	29

#define FN_REDREC	31
#define FN_RDVREC	32
#define FN_WRTREC	33
#define FN_WRTVREC	34

#define FN_NEWREC	41
#define FN_NEWVREC	42
#define FN_RETREC	43
#define FN_RETVREC	44

#define FN_LOKREC	51
#define FN_EQLKEY	52
#define FN_DLOCK	53
#define FN_UDLOCK	54
#define FN_FLUSHDOS	55
#define FN_RLOCK	56
#define FN_MLTULK	57

#define FN_FLOWKEY	60
#define FN_FRCKEY	60
#define FN_FRSKEY	61
#define FN_LSTKEY	62
#define FN_NXTKEY	63
#define FN_PRVKEY	64

#define FN_FTWOKEY	65
#define FN_GTEKEY	65
#define FN_GTKEY	66
#define FN_LTEKEY	67
#define FN_LTKEY	68
#define FN_LLOWKEY	69

#define FN_IDXENT	71
#define FN_DATENT	72
#define FN_GTVLEN	73
#define FN_SERIALNUM	74

#define CNT_RECIN	101
#define CNT_RECOUT	102
#define CNT_HDROUT	103
#define CNT_FILEXT	104
#define FN_TSTREC	105

#define FN_MLTWRT	149
#define TST_MLTOPS	150
#define FN_MLTKEY	151

#define FN_STATUS	160
#define FN_STFILE	161

#define FN_YOURFUNC	170	/* reserved for your use */

#define TST_MESSAGE	200
#define TST_MSGSIZ	201	/* regular logon */
#define TST_STPSRV	202	/* stop server */
#define TST_STPUSR	203	/* stop user */
#define TST_BADFIL	204	/* bad file number signal */
#define TST_DEDUSR	205	/* check for a dead user */
#define TST_EXISTS	206	/* received a heart beat signal */
#define TST_TRAN	207	/* transaction request */
#define TST_SPCLOG	208	/* special logon even if shutting down */
#define TST_SMSG	209	/* special driver control message not seen
				   by ctsrvr
				*/
#define TST_YOURTEST	210	/* reserved for your use */
#define MAX_FUNC	211	/* **************************************** */

/* end of ctcomm.h */
