# Make library for c-tree application library
# invoke with MAKEALIB.BAT

RTREE=..\..\rtree
COMPILER=cl /c
ASM=masm
CM=/AS
LM=S
AM=SMALL
D=SAPP
P=/I .\ /I ..\ /I ..\msc /I $(RTREE)
LN=ctalib
NV=..\nov$$(LM)app
ALIB=$(LN).lib
RLIB=$(LN)+$(NV)
LINK=link

# library modules

$(D)\ctappx.obj: ..\ctappx.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx2.obj: ..\ctapx2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx3.obj: ..\ctapx3.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx4.obj: ..\ctapx4.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctamsg.obj: ctamsg.c ctaxit.h
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctaxit.obj: ctaxit.asm
	$(ASM) $*;
	copy $*.obj $(D)\*.*
	del $*.obj

$(D)\ctsset.obj: ..\ctsset.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctisam.obj: ..\ctisam.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrec.obj: ..\ctvrec.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrcu.obj: ..\ctvrcu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctestm.obj: ..\ctestm.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctism2.obj: ..\ctism2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismc.obj: ..\ctismc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismo.obj: ..\ctismo.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\cticre.obj: ..\cticre.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctiopn.obj: ..\ctiopn.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\cticls.obj: ..\cticls.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctifil.obj: ..\ctifil.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismu.obj: ..\ctismu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctcomp.obj: ..\ctcomp.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclb2.obj: ..\ctclb2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctalib.lib:	$(D)\ctappx.obj $(D)\ctapx2.obj $(D)\ctamsg.obj \
			$(D)\ctcomp.obj $(D)\ctapx3.obj $(D)\ctapx4.obj \
			$(D)\ctsset.obj $(D)\ctisam.obj $(D)\ctvrec.obj \
			$(D)\ctvrcu.obj $(D)\ctism2.obj $(D)\ctaxit.obj \
			$(D)\ctismc.obj $(D)\ctismo.obj $(D)\cticre.obj \
			$(D)\ctiopn.obj $(D)\ctestm.obj \
			$(D)\cticls.obj $(D)\ctifil.obj \
			$(D)\ctismu.obj $(D)\ctclb2.obj
	cd $(D)
	del ctalib.bak
	ren ctalib.lib ctalib.bak
	echo ctalib.lib > lrsp
	echo y >> lrsp
	echo +ctappx+ctapx2+ctamsg+ctaxit+ctcomp & >> lrsp
	echo +ctsset+ctisam+ctvrec+ctvrcu+ctism2 & >> lrsp
	echo +ctismc+ctismo+cticre & >> lrsp
	echo +ctiopn+ctestm & >> lrsp
	echo +cticls+ctifil & >> lrsp
	echo +ctismu+ctapx3+ctapx4 & >> lrsp
	echo +ctclb2 >> lrsp
	echo ctalib.m >> lrsp
	echo ctalib.lib >> lrsp
	lib @lrsp
	del lrsp
	cd ..

$(D)\ctexmc.obj: ..\ctexmc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctexmc.exe: $(D)\ctexmc.obj $(D)\ctalib.lib
	cd $(D)
	$(LINK) ctexmc,,,$(RLIB);
	cd ..

$(D)\ctexmg.obj: ..\ctexmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctexmg.exe: $(D)\ctexmg.obj $(D)\ctalib.lib
	cd $(D)
	$(LINK) ctexmg/m,,,$(RLIB);
	cd ..

$(D)\ctstop.obj: ..\ctstop.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctstop.exe: $(D)\ctstop.obj $(D)\ctamsg.obj $(D)\ctaxit.obj $(D)\ctclb2.obj
	cd $(D)
	$(LINK) ctstop+ctamsg+ctaxit+ctclb2,,,$(NV);
	cd ..

$(D)\ctstat.obj: ..\ctstat.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctstat.exe: $(D)\ctstat.obj $(D)\ctamsg.obj $(D)\ctaxit.obj $(D)\ctclb2.obj
	cd $(D)
	$(LINK) ctstat+ctamsg+ctaxit+ctclb2,,,$(NV);
	cd ..

$(D)\ctvxmg.obj: ..\ctvxmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvxmg.exe: $(D)\ctvxmg.obj $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctvxmg,,,$(RLIB);
	cd ..

$(D)\ctixmg.obj: ..\ctixmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctixmg.exe: $(D)\ctixmg.obj $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctixmg,,,$(RLIB);
	cd ..

$(D)\ctpkey.obj: ..\ctpkey.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctpkey.exe: $(D)\ctpkey.obj $(D)\$(ALIB)
	cd $(D)
	$(LINK) $*,,,$(RLIB);
	cd ..

# end
